---
title: Rotate OAuth Client Secret
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/python)

[IAM](https://developers.cloudflare.com/api/python/resources/iam)

[OAuth Clients](https://developers.cloudflare.com/api/python/resources/iam/subresources/oauth_clients)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Rotate OAuth Client Secret

iam.oauth\_clients.rotate\_secret(stroauth\_client\_id, OAuthClientRotateSecretParams\*\*kwargs) -> [OAuthClientRotateSecretResponse](<https://developers.cloudflare.com/api/python/resources/iam#(resource)%20iam.oauth_clients%20%3E%20(model)%20oauth_client_rotate_secret_response%20%3E%20(schema)>)

POST/accounts/{account\_id}/oauth\_clients/{oauth\_client\_id}/rotate\_secret

Creates a second client secret so you can update your client configuration before deleting the old one. The `has_rotated_secret` field on the client will be set to `true`.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`OAuth Client Write`

##### ParametersExpand Collapse

account\_id: str

Account identifier tag.

maxLength32

minLength32

[Link to this property](<#(resource)%20iam.oauth_clients%20%3E%20(method)%20rotate_secret%20%3E%20(params)%20default%20%3E%20(param)%20account_id%20%3E%20(schema)>)

oauth\_client\_id: str

The unique identifier for an OAuth client.

[Link to this property](<#(resource)%20iam.oauth_clients%20%3E%20(method)%20rotate_secret%20%3E%20(params)%20default%20%3E%20(param)%20oauth_client_id%20%3E%20(schema)>)

##### ReturnsExpand Collapse

<details>

<summary>

class OAuthClientRotateSecretResponse: …

</summary>

client\_secret: Optional\[str]

The new client secret.

<a href="#(resource)%20iam.oauth_clients%20%3E%20(model)%20oauth_client_rotate_secret_response%20%3E%20(schema)%20%3E%20(property)%20client_secret">Link to this property</a>

</details>

[Link to this property](<#(resource)%20iam.oauth_clients%20%3E%20(model)%20oauth_client_rotate_secret_response%20%3E%20(schema)>)

### Rotate OAuth Client Secret

Python

HTTPTypeScriptPythonGoTerraform

```
import os
from cloudflare import Cloudflare

client = Cloudflare(
    api_token=os.environ.get("CLOUDFLARE_API_TOKEN"),  # This is the default and can be omitted
)
response = client.iam.oauth_clients.rotate_secret(
    oauth_client_id="a1b2c3d4e5f6a1b2c3d4e5f6a1b2c3d4",
    account_id="023e105f4ecef8ad9ca31a8372d0c353",
)
print(response.client_secret)
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "client_secret": "cf-oauth-secret-new-example"
  }
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "client_secret": "cf-oauth-secret-new-example"
  }
}
```